#ifdef __cplusplus
extern "C" {
#endif

#if defined(_MSC_VER) || defined(__BORLAND_C__)
#include <pshpack1.h>
#define PACKED
#elif defined(__GNUC__)
#define PACKED __attribute__ ((packed))
#else
#define PACKED
#endif

#define MapObjName "MDXDRV work"
#define MapObjNameStatus "MDXDRV Sequence status [MDX]"
#define MutexObjName "MDXDRV WIN32"
#define memIDmax (32)

typedef signed char int8;
typedef unsigned char uint8;
typedef signed int int32;
typedef unsigned int uint32;

typedef struct MdxdrvStatusTag {
	int32	InterLock;
	int32	IntCount;
	uint32	BootTime;
	uint32	BuffSize;
	uint8	DriverID		PACKED;
	uint8	CallDriverID	PACKED;
	int8	b2				PACKED;
	int8	b3				PACKED;
	int32	i2;
	int32	i3;
	int32	i4;
	int8	ID[memIDmax];
	int32	load;
	int8	buff[1024*4];
} MdxdrvStatus ;

#if defined(_MSC_VER) || defined(__BORLAND_C__)
#include <poppack.h>
#endif

#ifdef __cplusplus
}
#endif
