/*
	KUMAamp project()
	Copyright (C) Mamiya 2000.
	License:GPL
	---------------------------------------------------------------------------
	SPC sub
	spc.c
*/

#include "in_mdx.h"

/* ANSI/Windows standard headers */
#include <windows.h>

/* Project headers */
#include "spc.h"

void GetTitleSPC(char *fn, char *title)
{
	HANDLE hFile = CreateFile(
		fn,
		GENERIC_READ,
		FILE_SHARE_READ,
		NULL,
		OPEN_EXISTING,
		FILE_ATTRIBUTE_ARCHIVE |
		FILE_ATTRIBUTE_COMPRESSED |
		FILE_ATTRIBUTE_HIDDEN |
		FILE_ATTRIBUTE_OFFLINE |
		FILE_ATTRIBUTE_READONLY |
		FILE_ATTRIBUTE_SYSTEM |
		FILE_ATTRIBUTE_TEMPORARY,
		NULL);
	if (hFile != INVALID_HANDLE_VALUE)
	{
		DWORD i, len = 0;
		char buf[32], *p = title;
		SetFilePointer(hFile, 46 + 32, NULL, FILE_BEGIN);
		if (ReadFile(hFile, buf, sizeof(buf), &len, NULL) && buf[0] != '\x00')
		{
			for (i = 0; i < len; i++)
			{
				if (buf[i] == '\x00') break;
				*(p++) = buf[i];
			}
		}
		SetFilePointer(hFile, 46, NULL, FILE_BEGIN);
		if (ReadFile(hFile, buf, sizeof(buf), &len, NULL) && buf[0] != '\x00')
		{
			if (p != title) *(p++) = ' ';
			*(p++) = '[';
			*(p++) = ' ';
			for (i = 0; i < len; i++)
			{
				if (buf[i] == '\x00') break;
				*(p++) = buf[i];
			}
			*(p++) = ' ';
			*(p++) = ']';
		}
		*p = '\0';
		CloseHandle(hFile);
	}
}

void GetTimeSPC(char *fn, int *time_in_ms)
{
	HANDLE hFile = CreateFile(
		fn,
		GENERIC_READ,
		FILE_SHARE_READ,
		NULL,
		OPEN_EXISTING,
		FILE_ATTRIBUTE_ARCHIVE |
		FILE_ATTRIBUTE_COMPRESSED |
		FILE_ATTRIBUTE_HIDDEN |
		FILE_ATTRIBUTE_OFFLINE |
		FILE_ATTRIBUTE_READONLY |
		FILE_ATTRIBUTE_SYSTEM |
		FILE_ATTRIBUTE_TEMPORARY,
		NULL);
	if (hFile != INVALID_HANDLE_VALUE)
	{
		DWORD i, len = 0;
		char buf[3];
		SetFilePointer(hFile, 0xa9, NULL, FILE_BEGIN);
		if (ReadFile(hFile, buf, 3, &len, NULL) && len == 3 && buf[0] >= '0')
		{
			*time_in_ms = 0;
			for (i = 0; i < len; i++)
			{
				if (buf[i] < '0') break;
				*time_in_ms = *time_in_ms * 10 + (buf[i] - '0');
			}
			*time_in_ms *= 1000;	/* sec to ms */
		}
		CloseHandle(hFile);
	}
}
